# -*- coding: utf-8 -*-
# Generated by Django 1.11.5 on 2017-11-01 16:19
from __future__ import unicode_literals

from django.db import migrations

# Creates UserObjectPermission objects which allow specific users
# to add events for pipelines.  Based on current production database
# content (27 October 2017)

# List of pipeline names and lists of usernames who should
# be allowed to add events for them
PP_LIST = [
    {
        'pipeline': 'gstlal',
        'usernames': [
            'cody.messick@LIGO.ORG',
        ]
    },
    {
        'pipeline': 'pycbc',
        'usernames': [
            'gareth.davies@LIGO.ORG',
        ]
    },
]

def add_permissions(apps, schema_editor):
    User = apps.get_model('auth', 'User')
    Permission = apps.get_model('auth', 'Permission')
    UserObjectPermission = apps.get_model('guardian', 'UserObjectPermission')
    Pipeline = apps.get_model('events', 'Pipeline')
    ContentType = apps.get_model('contenttypes', 'ContentType')

    perm = Permission.objects.get(codename='populate_pipeline')
    ctype = ContentType.objects.get_for_model(Pipeline)
    for pp_dict in PP_LIST:
        pipeline = Pipeline.objects.get(name=pp_dict['pipeline'])

        # Loop over users
        for username in pp_dict['usernames']:

            # Robot users should have been already created by ligoauth 0003,
            # but we have to create human user accounts here
            user, _ = User.objects.get_or_create(username=username)

            # Create UserObjectPermission
            uop, uop_created = UserObjectPermission.objects.get_or_create(
                user=user, permission=perm, content_type=ctype,
                object_pk=pipeline.id)

def remove_permissions(apps, schema_editor):
    pass

class Migration(migrations.Migration):

    dependencies = [
        ('guardian', '0006_authorize_emfollow_to_populate_pipelines'),
    ]

    operations = [
        migrations.RunPython(add_permissions, remove_permissions),
    ]